<?php
	require_once(CI_PATH_LIBS.'/skype.inc.php');
	
	class S2P_API_MODULE_PROFILE extends S2P_API_MODULE
	{
		function S2P_API_MODULE_PROFILE()
		{
		}

		function run($args)
		{
			switch ($args['task'])
			{
				case 'create':
				case 'save':
				case 'modify':	return $this->task_save($args);
				case 'toggle':	return $this->task_toggle($args);
				case 'remove':	return $this->task_remove($args);
				case 'list':	return $this->task_list($args);
				case 'info':	return $this->task_info($args);
			}

			return $this->error_no_task();
		}

		function task_info($args)
		{
			$manager=new CI_SKYPE_PROFILES();

			$info=$manager->get_info($args['id']);
			if (!$info) return ci_response_error('missing-id');
			
			return ci_response_ok($info);
		}

		function task_list($args)
		{
			$manager=new CI_SKYPE_PROFILES();
			return ci_response_ok(array('item' => $manager->get_list()));
		}

		function task_save($args)
		{
			$manager=new CI_SKYPE_PROFILES();
			return $manager->task_save($_REQUEST);
		}

		function task_remove($args)
		{
			$manager=new CI_SKYPE_PROFILES();
			return $manager->task_delete($_REQUEST['id']);
		}

		function task_toggle($args)
		{
			$manager=new CI_SKYPE_PROFILES();
			return $manager->task_toggle($_REQUEST['id']);
		}
	}
?>