var HashCookie = new Hash.Cookie('castiron');
var ci_slide_menu;
var ci_slide_apply;
var ci_login_visible=false;
var ci_current_page;
var ci_last_page;
var ci_reload_timeout;

function ci_urlencode(CODE)
{
	var plaintext = CODE;

	var SAFECHARS = "0123456789" +
					"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +
					"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()"
	;					
	var HEX = "0123456789ABCDEF";
	
	var encoded = "";
	for (var i = 0; i < plaintext.length; i++ )
	{
		var ch = plaintext.charAt(i);
	    if (ch == " ")
	    {
		    encoded += "+";
		}
		else if (SAFECHARS.indexOf(ch) != -1)
		{
		    encoded += ch;
		}
		else
		{
		    var charCode = ch.charCodeAt(0);
			if (charCode > 255)
			{
			    alert( "Unicode Character '" + ch + "' cannot be encoded using standard URL encoding.\n" +
				        "(URL encoding only supports 8-bit characters.)\n" +
						"A space (+) will be substituted." );
				encoded += "+";
			}
			else
			{
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	}

	return encoded;
}


/* Page autoreload */
function ci_set_reload_page(interval)
{
	if (ci_reload_timeout) return;
	
	ci_reload_timeout=window.setTimeout(function() {
		if (ci_reload_timeout)
			ci_load_page(ci_current_page, false);
	}, interval);
}

/* Remove duplicates on arrays */
function ci_array_unique(a)
{
	var hsh=new Hash();
	for (var i=0; i<a.length; i++) hsh.set(a[i], true);
	return hsh.keys();
}

/* Remove an item in array */
function ci_array_remove(haystack, needle)
{
	var out=new Array();

	for (var i=0; i<haystack.length; i++)
		if (haystack[i] != needle) out.push(haystack[i]);

	return out;
}

/* MAP sort */
function ci_array_map_sort(items, map)
{
	var out=new Array();
	for (var i=0; i<map.length; i++) out[i]=items[map[i]];

	return out;
}

/* Fix PNG */
function ci_fix_png_one(item)
{
	if (!window.ie6) return;
	
	var w=item.getSize().size.x;
	var h=item.getSize().size.y;

	item.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + item.getProperty('src') + "')";
	item.src2=item.getProperty('src');

	item.src=ci_uri_base+"/img/blank.gif";
	item.style.width=w+'px';
	item.style.height=h+'px';
}

function ci_fix_png()
{
	if (!window.ie6) return;
	
	$$('img').each(function(item)
	{
		if (item.getTag() == 'img' && item.getProperty('src').substring(item.getProperty('src').length  - 3) == 'png') ci_fix_png_one(item)
	});
}

/* Cookie functions */
function ci_cookie_set(key, val)
{
	HashCookie.set(key, val);
}

/* Cookie functions */
function ci_cookie_get(key)
{
	return HashCookie.get(key);
}

function ci_show_loader()
{
	$('ajax_loader').style.display='block';
}

function ci_hide_loader()
{
	$('ajax_loader').style.display='none';
}

/* Misc functions */
function ci_load_page(url, hide_while_loading)
{
	window.clearTimeout(ci_reload_timeout);
	ci_reload_timeout=0;
	
	ci_show_loader();

	if (hide_while_loading == null) hide_while_loading=true;

	$('page_loader').style.left		= $('page_content').getPosition().x+'px';
	$('page_loader').style.top		= $('page_content').getPosition().y+'px';
	$('page_loader').style.width	= $('page_content').getSize().size.x+'px';
	$('page_loader').style.height	= '400px';

	if ($('ci_error_message')) $('ci_error_message').style.display='none';

	if (hide_while_loading)
	{
		$('page_content').innerHTML="";
		$('page_content').style.visibility='hidden';

		$('page_loader').style.display='block';
	}

	var ajx=new Ajax(ci_uri_base+'/'+url, {
		evalScripts:	true,
		method:			'get',
		update:			$('page_content'),
		onComplete:		function() {
			ci_last_page=ci_current_page;
			ci_current_page=url;

			ci_hide_loader();
			ci_fix_document(ci_uri_base+'/'+url);
			ci_cookie_set('page', url);

			$('page_loader').style.display='none';
			$('page_content').style.visibility='visible';
		}
	}).request();
}

function ci_fix_document(url)
{
	/* Fix page height */
	var new_image_url=url.replace(/\/[^\/]+$/, '/index.png');

	/* PNG fix */
	if (window.ie6)
	{
		if (new_image_url != $('page_logo').src2) $('page_logo').src=new_image_url;
		ci_fix_png_one($('page_logo'));
//  	ci_fix_png();
	}
	else if (window.ie)
	{
		$('page_logo').src=new_image_url;
	}
	else if (window.mz)
	{
		if (new_image_url != $('page_logo').src)
		{
			var fx = new Fx.Styles($('page_logo'), {duration: 250, wait: false});
			fx.start({'opacity': 0.0}).chain(function() {
				$('page_logo').src=new_image_url;

				fx.start({'opacity': 0.5});
			});
		}
	}

	$$('*').each(function(el) {

		/* Input box handlers */
		if ((el.getTag() == 'select' || el.getTag() == 'input' || el.getTag() == 'textarea') && el.getProperty('type') != 'submit' && el.getProperty('type') != 'button')
		{
			el.addEvent('focus', function(event) {
				var fx = new Fx.Styles(el, {duration: 250, wait: false});
				fx.start({'background-color': "#ffffcc"});
			});
			el.addEvent('blur', function(event) {
				var fx = new Fx.Styles(el, {duration: 500, wait: false});
				fx.start({'background-color': "#ffffff"});
			});
		}
	});


	/* Load custom CSS */
	var lnk		= document.createElement("link");
	lnk.href	= url.replace(/\.php(\?*.*)$/, '.css');

	lnk.rel		= "stylesheet";
	lnk.type	= "text/css";
	
	document.body.appendChild(lnk);
}

function ci_hide_apply()
{
	if (!ci_slide_apply) ci_slide_apply = new Fx.Slide($('apply'), {mode: 'vertical'});
	ci_slide_apply.hide();
	$('page_content').style.marginBottom = "0px";
}

function ci_slideout_apply()
{
	if (!ci_slide_apply) ci_slide_apply = new Fx.Slide($('apply'), {mode: 'vertical'});
	ci_slide_apply.slideOut();
	$('page_content').style.marginBottom = "0px";
}

function ci_show_apply()
{
	if (!ci_slide_apply) ci_slide_apply = new Fx.Slide($('apply'), {mode: 'vertical'});
	ci_slide_apply.slideIn();
	$('page_content').style.marginBottom = "5px";
}

function ci_lock_screen()
{
	var a=window.getHeight();
	var b=$('container').getSize().scrollSize.y;

	h=(a>b) ? a : b;
	
	$('screenlock').setStyles({'width': window.getWidth()+'px', 'height':h+'px' });
	
	var fx = new Fx.Styles($('screenlock'), {duration: 500, wait: false});
 	fx.start({'opacity': 0.8});

  	$('screenlock_content').setStyles({display: 'block', left: ((window.getWidth()-700)/2)+'px', top: ((window.getHeight()-150)/2)+'px' });
}

function ci_unlock_screen()
{
	var fx = new Fx.Styles($('screenlock'), {duration: 500, wait: false});
 	fx.start({'opacity': 0.0});
 	$('screenlock_content').setStyles({display: 'none'});
}

function ci_init_lock_screen()
{
	$('screenlock').setStyles({opacity: '0'});
	$('screenlock_content').setStyles({display: 'none'});
}

function ci_do_apply()
{
	ci_lock_screen();
	ci_slideout_apply();

	var ajx=new Ajax(ci_uri_base+"/do_apply.php", {
		method:			'get',
		onComplete:		function() {
			ci_unlock_screen();
		}
	}).request();
}

function ci_hide_menu()
{
	if (!ci_slide_menu) ci_slide_menu = new Fx.Slide($('main_menu'), {mode: 'horizontal'});
	ci_slide_menu.hide();
}

function ci_show_menu()
{
	if (!ci_slide_menu) ci_slide_menu = new Fx.Slide($('main_menu'), {mode: 'horizontal'});
	ci_slide_menu.slideIn();

	$('page_content').style.marginLeft = "10px";
	$('page_content').style.width = "730px";
}

function ci_slideout_menu()
{
	if (!ci_slide_menu) ci_slide_menu = new Fx.Slide($('main_menu'), {mode: 'horizontal'});

	var fx2 = new Fx.Styles($('page_logo'), {duration:1000, wait:false});

	fx2.start({'opacity': 0.0}).chain(function() {
		ci_slide_menu.slideOut().chain(function() {
			var fx = new Fx.Styles($('page_content'), {duration: 1000, wait: false});

			fx.options.transition = Fx.Transitions.linear;
			fx.start({ 'margin': [0], 'width': [940] });

			$('page_logo').style.visibility="hidden";
		});
	});
}

function ci_slidein_menu()
{
	if (!ci_slide_menu) ci_slide_menu = new Fx.Slide($('main_menu'), {mode: 'horizontal'});
	
	var fx = new Fx.Styles($('page_content'), {duration: 1000, wait: false});

	fx.options.transition = Fx.Transitions.linear;
	fx.start({ 'margin-left': [10], 'width': [730] }).chain(function () {
		ci_slide_menu.slideIn().chain(function () {
												
			if (!window.ie6)
			{
				var fx2 = new Fx.Styles($('page_logo'), {duration:1000, wait:false});

				if (window.ie7)	fx2.start({'opacity': 1.0});
				else			fx2.start({'opacity': 0.5});
			}
			
			$('page_logo').style.visibility="visible";
		});
	});
}

function ci_blink_error(message, count)
{
	var item="ci_error_message";
	if (!$(item))
	{
		my_div=new Element('div');
		my_div.setProperty('id', item);
		my_div.setProperty('class', 'error');
		my_div.injectInside(document.body);
	}
	
	$(item).setHTML(message);

	$(item).style.display="inline";
	var item_left=((window.getWidth()-$(item).getSize().size.x))/2;
	var item_top=(window.getHeight()/2)+window.getScrollTop();

	$(item).style.position='absolute';
	$(item).style.left=item_left+'px';
	$(item).style.top=item_top+'px';

	if (!count) count=5;

	window.setTimeout(function() {
		$(item).style.display='none';
	}, count*1000);
}

function ci_hide_error_block(item)
{
	if (!$(item)) return;
	$(item).style.display='none';
}

function ci_blink_error_block(item, count, txt)
{
	if (!$(item)) return;
	
	$(item).className='error_block';
	$(item).style.display='block';

	$(item).innerHTML=txt;
}


function ci_blink_success_block(item, count, txt)
{
	if (!$(item)) return;
	
	$(item).className='success_block';
	$(item).style.display='block';
	$(item).innerHTML=txt;
}

function ci_reload_menu()
{
	var ajx=new Ajax(ci_uri_base+'/menu.php', {
		evalScripts:	true,
		method:			'get',
		update:			$('page_menu'),
		onComplete:		function() { }
	}).request();
}

function ci_show_login()
{
	if (ci_login_visible) return;

	ci_login_visible=true;

	var ajx2=new Ajax(ci_uri_base+"/page_head_login.php", {
		method:			'get',
		update:			$('logged_in'),
		onComplete:		function() {
			var fx = new Fx.Styles($('logged_in'), {duration:1000, wait:false});
			fx.start({'opacity': 1});
		}
	}).request();
}

function ci_hide_login()
{
	if (!ci_login_visible) return;

	ci_login_visible=false;
	var fx = new Fx.Styles($('logged_in'), {duration:1000, wait:false});
	fx.start({'opacity': 0});
}

function ci_action(url, dont_reload)
{
	ci_show_loader();
	
	var ajx=new Ajax(ci_uri_base+'/actions/'+url, {
		method:			'get',
		onComplete:		function(txt, xml) {
			res=ci_xml2array(xml);

			if (!dont_reload)
			{
				if (res['reply']['type'] == "ok")
				{
					ci_load_page(ci_current_page, false);
				}
				else
				{
					ci_blink_error(res['reply']['params']['desc']);
				}
			}
			
			ci_hide_loader();
			ci_check_apply();
		}
	}).request();
}

function ci_modal(url, caption, size)
{
	MOOdalBox.open(ci_uri_base+"/"+url, caption, size);
}

function ci_modal_confirm(id, text, callback)
{
	MOOdalBox.open(ci_uri_base+"/modals/confirm.php?id="+id+"&text="+escape(text)+"&callback="+callback, "Please confirm this operation", "500 180");
}

function ci_check_apply()
{
	var ajx=new Ajax(ci_uri_base+"/check_apply.php", {
		method:			'get',
		onComplete:		function(txt, xml) {
			res=ci_xml2array(xml);

			if (res["reply"]["status"] == "true")
				ci_show_apply();
			else
				ci_slideout_apply();
		}
	}).request();
}
