<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/tables.inc.php');
	require_once(CI_PATH_LIBS.'/buttons.inc.php');
	require_once(CI_PATH_LIBS.'/fields.inc.php');

	CI_AUTH::require_auth('admin', array('reply' => 'html'));

	$buttons=new CI_BUTTONS();
	$buttons->add_button(array(
 		'name'	=> 'load',
 		'icon'	=> $CI_URI_BASE.'/icons/buttons/import.png',
 		'label'	=> ci_lbl("system.updates.load")
 	));
?>
<script type="text/javascript">
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'load':	ci_load_page('system/updates/load.php'); break;
		}
	}
</script>

<div class="title"><?php echo ci_lbl("system.updates.title") ?></div>

<div class="text">
	<?php echo ci_lbl("system.updates.text", array('version' => ci_get_version())) ?>
</div>

<?php echo $buttons->get(); ?>
